****************************************************************************
****************************************************************************
**                                                                        **
**   Phoenix for Fargo II : Level Definitions and Initialization          **
**                                                                        **
**   Copyright 1997-2000 by Patrick Davidson.  All Rights Reserved.       **
**                                                                        **
**   This file was last updated May 7, 2000                               **
**                                                                        **
**   For complete copyright information and contact addresses, refer to   **
**   the main source file "PHOENIX.ASM"                                   **
**                                                                        **
****************************************************************************
****************************************************************************

******************************************** LEVEL DATA
*
* The tables below are the lists of levels that will be played in each
* difficulty level.  The use of these tables is described right before the
* level loader routine, which follows these tables.
*
********

level_table_easy:
         dc.b     LVL_1A,LVL_1B,LVL_1C,LVL_1A,LVL_1B,LVL_1C,LVL_Shop
         dc.b     LVL_2A,LVL_2B,LVL_2C,LVL_Triangles,LVL_2A,LVL_2B,LVL_2C,LVL_Triangles,LVL_Shop
         dc.b     LVL_3A,LVL_3B,LVL_3C,LVL_Triangles,LVL_3A,LVL_3B,LVL_3C,LVL_Triangles,LVL_Shop
         dc.b     LVL_4A,LVL_4B,LVL_4C,LVL_4A,LVL_4B,LVL_4C,LVL_Shop
         dc.b     LVL_5A,LVL_5B,LVL_5C,LVL_5A,LVL_5B,LVL_5C,LVL_Shop
         dc.b     LVL_6A,LVL_6B,LVL_6C,LVL_6A,LVL_6B,LVL_6C,LVL_Shop
         dc.b     LVL_7A,LVL_7B,LVL_7C,LVL_7A,LVL_7B,LVL_7C,LVL_Shop
         dc.b     LVL_8A,LVL_8B,LVL_8C,LVL_8A,LVL_8B,LVL_8C,LVL_Shop
         dc.b     LVL_SuperBoss,LVL_Free_Ship,LVL_Shop
         dc.b     LVL_Wheel5,LVL_MWheel8,LVL_Wheel5,LVL_MWheel8,LVL_Shop
         dc.b     LVL_X1,LVL_X2,LVL_X3,LVL_X1,LVL_X2,LVL_X3
         dc.b     LVL_Restart

level_table_medium:
         dc.b     LVL_1A,LVL_1B,LVL_1C,LVL_1A,LVL_1B,LVL_1C,LVL_Shop
         dc.b     LVL_2A,LVL_2B,LVL_2C,LVL_Triangles,LVL_2A,LVL_2B,LVL_2C,LVL_Triangles,LVL_Shop
         dc.b     LVL_3A,LVL_3B,LVL_3C,LVL_Triangles,LVL_3A,LVL_3B,LVL_3C,LVL_Triangles,LVL_Shop
         dc.b     LVL_4A,LVL_4A,LVL_4A,LVL_4B,LVL_4B,LVL_4B,LVL_4C,LVL_4C,LVL_4C,LVL_Shop
         dc.b     LVL_5A,LVL_5B,LVL_5C,LVL_5A,LVL_5B,LVL_5C,LVL_Shop
         dc.b     LVL_6A,LVL_6B,LVL_6C,LVL_6A,LVL_6B,LVL_6C,LVL_Shop
         dc.b     LVL_7A,LVL_7B,LVL_7C,LVL_7A,LVL_7B,LVL_7C,LVL_Shop
         dc.b     LVL_8A,LVL_8B,LVL_8C,LVL_8A,LVL_8B,LVL_8C,LVL_Shop
         dc.b     LVL_SuperBoss,LVL_Free_Ship,LVL_Shop
         dc.b     LVL_Wheel5,LVL_Wheel8,LVL_MWheel10,LVL_Wheel5,LVL_Wheel8,LVL_MWheel10,LVL_Shop
         dc.b     LVL_X1,LVL_X2,LVL_X3,LVL_X1,LVL_X2,LVL_X3,LVL_Shop
         dc.b     LVL_O,LVL_O3,LVL_O5,LVL_O5,LVL_O,LVL_O3,LVL_O5,LVL_O5
         dc.b     LVL_SuperBoss_Plus
         dc.b     LVL_Restart

level_table_hard:
         dc.b     LVL_1A,LVL_1B,LVL_1C,LVL_1A,LVL_1B,LVL_1C,LVL_Shop
         dc.b     LVL_2A,LVL_2B,LVL_2C,LVL_Triangles,LVL_2A,LVL_2B,LVL_2C,LVL_Triangles,LVL_Shop
         dc.b     LVL_3A,LVL_3B,LVL_3C,LVL_Triangles,LVL_3A,LVL_3B,LVL_3C,LVL_Triangles,LVL_Shop
         dc.b     LVL_4A,LVL_4A,LVL_4A,LVL_4B,LVL_4B,LVL_4B,LVL_4C,LVL_4C,LVL_4C,LVL_Shop
         dc.b     LVL_5A,LVL_5B,LVL_5C,LVL_5A,LVL_5B,LVL_5C,LVL_Shop
         dc.b     LVL_6A,LVL_6B,LVL_6C,LVL_6A,LVL_6B,LVL_6C,LVL_Shop
         dc.b     LVL_7A,LVL_7B,LVL_7C,LVL_7A,LVL_7B,LVL_7C,LVL_Shop
         dc.b     LVL_8A,LVL_8B,LVL_8C,LVL_8A,LVL_8B,LVL_8C,LVL_Shop
         dc.b     LVL_SuperBoss,LVL_SuperBoss,LVL_Shop
         dc.b     LVL_Wheel5,LVL_Wheel8,LVL_Wheel10,LVL_MWheel15,LVL_Wheel5,LVL_Wheel8,LVL_Wheel10,LVL_MWheel15,LVL_Shop
         dc.b     LVL_X1,LVL_X2,LVL_X3,LVL_X1,LVL_X2,LVL_X3,LVL_Shop
         dc.b     LVL_O,LVL_O3,LVL_O5,LVL_O5,LVL_O,LVL_O3,LVL_O5,LVL_O5
         dc.b     LVL_SuperBoss_Plus
         dc.b     LVL_Restart

level_table_expert:
         dc.b     LVL_1A,LVL_1B,LVL_1C,LVL_1A,LVL_1B,LVL_1C
         dc.b     LVL_2A,LVL_2B,LVL_2C,LVL_Triangles,LVL_2A,LVL_2B,LVL_2C,LVL_Triangles,LVL_Shop
         dc.b     LVL_3A,LVL_3B,LVL_3C,LVL_Triangles,LVL_3A,LVL_3B,LVL_3C,LVL_Triangles
         dc.b     LVL_4A,LVL_4A,LVL_4A,LVL_4B,LVL_4B,LVL_4B,LVL_4C,LVL_4C,LVL_4C,LVL_Shop
         dc.b     LVL_5A,LVL_5B,LVL_5C,LVL_5A,LVL_5B,LVL_5C
         dc.b     LVL_6A,LVL_6B,LVL_6C,LVL_6A,LVL_6B,LVL_6C,LVL_Shop
         dc.b     LVL_7A,LVL_7B,LVL_7C,LVL_7A,LVL_7B,LVL_7C
         dc.b     LVL_8A,LVL_8B,LVL_8C,LVL_8A,LVL_8B,LVL_8C,LVL_Shop
         dc.b     LVL_SuperBoss,LVL_SuperBoss,LVL_Shop
         dc.b     LVL_Wheel5,LVL_Wheel8,LVL_Wheel10,LVL_MWheel15,LVL_Wheel5,LVL_Wheel8,LVL_Wheel10,LVL_MWheel15,LVL_Shop
         dc.b     LVL_X1,LVL_X2,LVL_X3,LVL_X1,LVL_X2,LVL_X3
         dc.b     LVL_O,LVL_O3,LVL_O5,LVL_O5,LVL_O,LVL_O3,LVL_O5,LVL_O5,LVL_Shop
         dc.b     LVL_SuperBoss_Plus,LVL_SuperBoss_Plus
         dc.b     LVL_Restart

         EVEN
         
******************************************** LIST OF LEVEL DATA TABLES
*
* This table is a list of pointers, which holds a level list for each
* difficulty level.
*
********

Level_Sets:
         dc.w     level_table_easy-Level_Sets
         dc.w     level_table_medium-Level_Sets
         dc.w     level_table_hard-Level_Sets
         dc.w     level_table_expert-Level_Sets

******************************************** LOAD NEXT LEVEL
*
* This routine initializes the next level.  It is called from the game's main
* loop whenever no enemies remain.  It calls the code assoiated with the next
* level.  This code normally initializes the enemies and then returns.
* Special game features, such as the shop and the free ship selection, are
* also implemented as "levels"; in these cases, the special function is
* performed in the level initialization code, and the number of enemies
* remaining is left at 0 so the next level will start immediately after.  The
* end of the game is also a "level" which displays the scoring screens and
* then restarts the game.
*
* The level loader itself will be called with A1 pointing to enemies_data,
* and D6 containg the default enemy destuction routine (these values are
* useful as defaults for the enemy installation code).
*
* The first step in initializing a level is to find the level index (that
* is, the index in the level table).  First, the list of levels for the
* particular difficulty level is located.  This is done by using the
* difficulty level as in index into the Level_Sets table above to obtain the
* offset of the level table (as a word) and from that the address of the
* level table itself.  Then, the current position in the game (level_number)
* is added to that address, and the byte there is the level index.
*
* Once the level index is known, the level code itself can then be located.
* The next step is to get the level's offset.  This is done by indexing into
* Level_Table, which yields the level code's address, as an offset from
* Level_Table.  This offset is then used to jump to the address of the level
* code itself.
*
********

Next_Level:
         clr.w    special_weapon_delay(a5)   

         move.w   difficulty(a5),d0          ;D0 = difficulty level
         add.w    d0,d0                      ;D0 = index into Level_Sets + 2
         move.w   Level_Sets-2(pc,d0.w),d0   ;D0 = offset of level list
         lea      Level_Sets(pc,d0.w),a0     ;A0 -> level list

         add.w    level_number(a5),a0        ;A0 -> level index
         addq.w   #1,level_number(a5)        ;increment level number
         moveq    #0,d0
         move.b   (a0),d0                    ;D0 = level index

         lea      enemies_data,a1
         move.w   #EDestruct_Normal-Enemy_Collisions,d6

         add.w    d0,d0                      ;D0 = index into Level_Table
         move.w   Level_Table(pc,d0.w),d0    ;D0 = offset of level's code
         jmp      Level_Table(pc,d0.w)       ;Jump to level's code

         INCLUDE  levels2.asm
