****************************************************************************
****************************************************************************
**                                                                        **
**   Phoenix for Fargo II : Screen Side Drawing Routines                  **
**                                                                        **
**   Copyright 1997-1999 by Patrick Davidson.  All Rights Reserved.       **
**                                                                        **
**   This file was last updated May 11, 2000                              **
**                                                                        **
**   For complete copyright information and contact addresses, refer to   **
**   the main source file "PHOENIX.ASM"                                   **
**                                                                        **
****************************************************************************
****************************************************************************

******************************************** DISPLAY SIDES OF SCREEN BUFFER

Display_Screen_Sides:                             
	LEA	642(A5),A0
         LEA      LCD_MEM+$1E,A1
	MOVEQ	#119,D0
_LAB_0124:
	MOVE.L	(A0)+,(A1)+
         lea      20(a0),a0
         lea      20(a1),a1
	MOVE.L	(A0)+,(A1)+
	ADDQ.L	#4,A0
	ADDQ.L	#2,A1
         DBF      D0,_LAB_0124
	RTS
        
******************************************** SCROLL SIDES OF SCREEN

Scroll_Side:
         lea      funky_flag(pc),a0          ; Fix inverting
         move.b   inv(a5),d0
         cmp.b    (a0),d0
         beq.s    invingok

         not.b    (a0)
         move.w   #255,d0
loopinvside:
         not.l    -(a0)
         dbra     d0,loopinvside

invingok:
         move.w   bpos(a5),d0
         addq.w   #1,d0
         cmp.w    #8*sects,d0
         bne.s    skip_1
         moveq    #0,d0
skip_1:
         move.w   d0,bpos(a5)
         and.w    #7,d0
         bne.s    not_on_boundary
         move.w   bpos(a5),d1
         lsr.w    #3,d1
         add.w    d1,d1
         add.w    d1,d1
         lea      Sides_Pattern(pc),a1
         add.w    d1,a1
         moveq    #14,d3
         lea      sides_data+60(a5),a2
Slide_Up_Sides:
         move.l   -4(a2),(a2)
         subq.l   #4,a2
         dbra     d3,Slide_Up_Sides
         move.l   (a1),(a2)
not_on_boundary:

         lea      sides_data+64(a5),a2
         lsl.w    #5,d0
         lea      2+640-(32*7)+(128*32)-4(a5),a0
         add.w    d0,a0
         move.b   inv(a5),d0
         ext.w    d0
         ext.l    d0
         move.l   d0,d2
         move.l   d0,d4
         move.l   d0,d5
         move.l   d0,d6
         moveq    #15,d1
Draw_Blox:
         move.w   -(a2),d3
         lea      Blk0(pc,d3.w),a3
         move.w   -(a2),d3
         lea      Blk0(pc,d3.w),a4
         moveq    #7,d7
Draw_Line:
         move.l   (a3)+,-(a0)
         movem.l  d0/d2/d4/d5/d6,-(a0)
         move.l   (a4)+,-(a0)
         subq.l   #4,a0
         dbra     d7,Draw_Line
         dbra     d1,Draw_Blox
         rts

******************************************** SCREEN SIDE BLOCKS

Blk0:
         dc.l     %11111111000000000000000000000000
         dc.l     %11111111000000000000000000000000
         dc.l     %11111111000000000000000000000000
         dc.l     %11111111000000000000000000000000
         dc.l     %11111111000000000000000000000000
         dc.l     %11111111000000000000000000000000
         dc.l     %11111111000000000000000000000000
         dc.l     %11111111000000000000000000000000

         dc.l     %11111111000000000000000000000000
         dc.l     %11111111100000000000000000000000
         dc.l     %11111111110000000000000000000000
         dc.l     %11111111111000000000000000000000
         dc.l     %11111111111100000000000000000000
         dc.l     %11111111111110000000000000000000
         dc.l     %11111111111111000000000000000000
         dc.l     %11111111111111100000000000000000

         dc.l     %11111111000000000000000000000000
         dc.l     %11111111110000000000000000000000
         dc.l     %11111111111100000000000000000000
         dc.l     %11111111111111000000000000000000
         dc.l     %11111111111111110000000000000000
         dc.l     %11111111111111111100000000000000
         dc.l     %11111111111111111111000000000000
         dc.l     %11111111111111111111110000000000

         dc.l     %11111111000000000000000000000000
         dc.l     %11111111111000000000000000000000
         dc.l     %11111111111111000000000000000000
         dc.l     %11111111111111111000000000000000
         dc.l     %11111111111111111111000000000000
         dc.l     %11111111111111111111111000000000
         dc.l     %11111111111111111111111111000000
         dc.l     %11111111111111111111111111111000

         dc.l     %11111111111111110000000000000000
         dc.l     %11111111111111100000000000000000
         dc.l     %11111111111111000000000000000000
         dc.l     %11111111111110000000000000000000
         dc.l     %11111111111100000000000000000000
         dc.l     %11111111111000000000000000000000
         dc.l     %11111111110000000000000000000000
         dc.l     %11111111100000000000000000000000

         dc.l     %11111111111111110000000000000000
         dc.l     %11111111111111110000000000000000
         dc.l     %11111111111111110000000000000000
         dc.l     %11111111111111110000000000000000
         dc.l     %11111111111111110000000000000000
         dc.l     %11111111111111110000000000000000
         dc.l     %11111111111111110000000000000000
         dc.l     %11111111111111110000000000000000

         dc.l     %11111111111111110000000000000000
         dc.l     %11111111111111111000000000000000
         dc.l     %11111111111111111100000000000000
         dc.l     %11111111111111111110000000000000
         dc.l     %11111111111111111111000000000000
         dc.l     %11111111111111111111100000000000
         dc.l     %11111111111111111111110000000000
         dc.l     %11111111111111111111111000000000

         dc.l     %11111111111111110000000000000000
         dc.l     %11111111111111111100000000000000
         dc.l     %11111111111111111111000000000000
         dc.l     %11111111111111111111110000000000
         dc.l     %11111111111111111111111100000000
         dc.l     %11111111111111111111111111000000
         dc.l     %11111111111111111111111111110000
         dc.l     %11111111111111111111111111111100

         dc.l     %11111111111111111111111100000000
         dc.l     %11111111111111111111110000000000
         dc.l     %11111111111111111111000000000000
         dc.l     %11111111111111111100000000000000
         dc.l     %11111111111111110000000000000000
         dc.l     %11111111111111000000000000000000
         dc.l     %11111111111100000000000000000000
         dc.l     %11111111111000000000000000000000

         dc.l     %11111111111111111111111100000000
         dc.l     %11111111111111111111111000000000
         dc.l     %11111111111111111111110000000000
         dc.l     %11111111111111111111100000000000
         dc.l     %11111111111111111111000000000000
         dc.l     %11111111111111111110000000000000
         dc.l     %11111111111111111100000000000000
         dc.l     %11111111111111111000000000000000

         dc.l     %11111111111111111111111100000000
         dc.l     %11111111111111111111111100000000
         dc.l     %11111111111111111111111100000000
         dc.l     %11111111111111111111111100000000
         dc.l     %11111111111111111111111100000000
         dc.l     %11111111111111111111111100000000
         dc.l     %11111111111111111111111100000000
         dc.l     %11111111111111111111111100000000

         dc.l     %11111111111111111111111100000000
         dc.l     %11111111111111111111111110000000
         dc.l     %11111111111111111111111111000000
         dc.l     %11111111111111111111111111100000
         dc.l     %11111111111111111111111111110000
         dc.l     %11111111111111111111111111111000
         dc.l     %11111111111111111111111111111100
         dc.l     %11111111111111111111111111111110

         dc.l     %11111111111111111111111111111111
         dc.l     %11111111111111111111111111111000
         dc.l     %11111111111111111111111111000000
         dc.l     %11111111111111111111111000000000
         dc.l     %11111111111111111111000000000000
         dc.l     %11111111111111111000000000000000
         dc.l     %11111111111111000000000000000000
         dc.l     %11111111111000000000000000000000

         dc.l     %11111111111111111111111111111111
         dc.l     %11111111111111111111111111111100
         dc.l     %11111111111111111111111111110000
         dc.l     %11111111111111111111111111000000
         dc.l     %11111111111111111111111100000000
         dc.l     %11111111111111111111110000000000
         dc.l     %11111111111111111111000000000000
         dc.l     %11111111111111111100000000000000

         dc.l     %11111111111111111111111111111111
         dc.l     %11111111111111111111111111111110
         dc.l     %11111111111111111111111111111100
         dc.l     %11111111111111111111111111111000
         dc.l     %11111111111111111111111111110000
         dc.l     %11111111111111111111111111100000
         dc.l     %11111111111111111111111111000000
         dc.l     %11111111111111111111111110000000

         dc.l     %11111111111111111111111111111111
         dc.l     %11111111111111111111111111111111
         dc.l     %11111111111111111111111111111111
         dc.l     %11111111111111111111111111111111
         dc.l     %11111111111111111111111111111111
         dc.l     %11111111111111111111111111111111
         dc.l     %11111111111111111111111111111111
         dc.l     %11111111111111111111111111111111

         dc.l     %11111111111111111111111111111111
         dc.l     %11111111111111111111111111111111
         dc.l     %11111111111111111111111111111111
         dc.l     %11111111111111111111111111111111
         dc.l     %11111111111111111111111111111111
         dc.l     %11111111111111111111111111111111
         dc.l     %11111111111111111111111111111111
         dc.l     %11111111111111111111111111111111

         dc.l     %11111111111111111111111111111111
         dc.l     %01111111111111111111111111111111
         dc.l     %00111111111111111111111111111111
         dc.l     %00011111111111111111111111111111
         dc.l     %00001111111111111111111111111111
         dc.l     %00000111111111111111111111111111
         dc.l     %00000011111111111111111111111111
         dc.l     %00000001111111111111111111111111

         dc.l     %11111111111111111111111111111111
         dc.l     %00111111111111111111111111111111
         dc.l     %00001111111111111111111111111111
         dc.l     %00000011111111111111111111111111
         dc.l     %00000000111111111111111111111111
         dc.l     %00000000001111111111111111111111
         dc.l     %00000000000011111111111111111111
         dc.l     %00000000000000111111111111111111

         dc.l     %11111111111111111111111111111111
         dc.l     %00011111111111111111111111111111
         dc.l     %00000011111111111111111111111111
         dc.l     %00000000011111111111111111111111
         dc.l     %00000000000011111111111111111111
         dc.l     %00000000000000011111111111111111
         dc.l     %00000000000000000011111111111111
         dc.l     %00000000000000000000011111111111

         dc.l     %00000000111111111111111111111111
         dc.l     %00000001111111111111111111111111
         dc.l     %00000011111111111111111111111111
         dc.l     %00000111111111111111111111111111
         dc.l     %00001111111111111111111111111111
         dc.l     %00011111111111111111111111111111
         dc.l     %00111111111111111111111111111111
         dc.l     %01111111111111111111111111111111

         dc.l     %00000000111111111111111111111111
         dc.l     %00000000111111111111111111111111
         dc.l     %00000000111111111111111111111111
         dc.l     %00000000111111111111111111111111
         dc.l     %00000000111111111111111111111111
         dc.l     %00000000111111111111111111111111
         dc.l     %00000000111111111111111111111111
         dc.l     %00000000111111111111111111111111

         dc.l     %00000000111111111111111111111111
         dc.l     %00000000011111111111111111111111
         dc.l     %00000000001111111111111111111111
         dc.l     %00000000000111111111111111111111
         dc.l     %00000000000011111111111111111111
         dc.l     %00000000000001111111111111111111
         dc.l     %00000000000000111111111111111111
         dc.l     %00000000000000011111111111111111

         dc.l     %00000000111111111111111111111111
         dc.l     %00000000001111111111111111111111
         dc.l     %00000000000011111111111111111111
         dc.l     %00000000000000111111111111111111
         dc.l     %00000000000000001111111111111111
         dc.l     %00000000000000000011111111111111
         dc.l     %00000000000000000000111111111111
         dc.l     %00000000000000000000001111111111

         dc.l     %00000000000000001111111111111111
         dc.l     %00000000000000111111111111111111
         dc.l     %00000000000011111111111111111111
         dc.l     %00000000001111111111111111111111
         dc.l     %00000000111111111111111111111111
         dc.l     %00000011111111111111111111111111
         dc.l     %00001111111111111111111111111111
         dc.l     %00111111111111111111111111111111

         dc.l     %00000000000000001111111111111111
         dc.l     %00000000000000011111111111111111
         dc.l     %00000000000000111111111111111111
         dc.l     %00000000000001111111111111111111
         dc.l     %00000000000011111111111111111111
         dc.l     %00000000000111111111111111111111
         dc.l     %00000000001111111111111111111111
         dc.l     %00000000011111111111111111111111

         dc.l     %00000000000000001111111111111111
         dc.l     %00000000000000001111111111111111
         dc.l     %00000000000000001111111111111111
         dc.l     %00000000000000001111111111111111
         dc.l     %00000000000000001111111111111111
         dc.l     %00000000000000001111111111111111
         dc.l     %00000000000000001111111111111111
         dc.l     %00000000000000001111111111111111

         dc.l     %00000000000000001111111111111111
         dc.l     %00000000000000000111111111111111
         dc.l     %00000000000000000011111111111111
         dc.l     %00000000000000000001111111111111
         dc.l     %00000000000000000000111111111111
         dc.l     %00000000000000000000011111111111
         dc.l     %00000000000000000000001111111111
         dc.l     %00000000000000000000000111111111

         dc.l     %00000000000000000000000011111111
         dc.l     %00000000000000000000011111111111
         dc.l     %00000000000000000011111111111111
         dc.l     %00000000000000011111111111111111
         dc.l     %00000000000011111111111111111111
         dc.l     %00000000011111111111111111111111
         dc.l     %00000011111111111111111111111111
         dc.l     %00011111111111111111111111111111

         dc.l     %00000000000000000000000011111111
         dc.l     %00000000000000000000001111111111
         dc.l     %00000000000000000000111111111111
         dc.l     %00000000000000000011111111111111
         dc.l     %00000000000000001111111111111111
         dc.l     %00000000000000111111111111111111
         dc.l     %00000000000011111111111111111111
         dc.l     %00000000001111111111111111111111

         dc.l     %00000000000000000000000011111111
         dc.l     %00000000000000000000000111111111
         dc.l     %00000000000000000000001111111111
         dc.l     %00000000000000000000011111111111
         dc.l     %00000000000000000000111111111111
         dc.l     %00000000000000000001111111111111
         dc.l     %00000000000000000011111111111111
         dc.l     %00000000000000000111111111111111

         dc.l     %00000000000000000000000011111111
         dc.l     %00000000000000000000000011111111
         dc.l     %00000000000000000000000011111111
         dc.l     %00000000000000000000000011111111
         dc.l     %00000000000000000000000011111111
         dc.l     %00000000000000000000000011111111
         dc.l     %00000000000000000000000011111111
         dc.l     %00000000000000000000000011111111

funky_flag:
         dc.w     0

******************************************** SCREEN SIDE DESCRIPTIONS

sects    set      0
_sect    MACRO
sects    set      sects+1
         dc.w     \1*32,\2*32
         ENDM

Sides_Pattern:
         _sect    9,25
         _sect    6,23
         _sect    9,30
         _sect    4,26
         _sect    1,26
         _sect    4,24
         _sect    0,16
         _sect    0,17
         _sect    3,20
         _sect    14,17
         _sect    10,23 
         _sect    10,30
         _sect    10,26
         _sect    11,24
         _sect    15,16
         _sect    15,17
         _sect    15,21
         _sect    13,20
         _sect    6,18
         _sect    10,25
         _sect    10,23
         _sect    9,30
         _sect    4,26
         _sect    2,26
         _sect    9,26
         _sect    7,24
         _sect    14,16
         _sect    11,17
         _sect    12,20
         _sect    0,19
         _sect    0,30
         _sect    1,25
         _sect    5,23
         _sect    6,25
         _sect    10,21
         _sect    10,20
         _sect    11,18
         _sect    12,27
         _sect    2,29
         _sect    10,22
         _sect    11,27
         _sect    14,30
Sides_Pattern_End:
